<template>
  <div id="app">
    <div class="container bg">
      <p>{{ randomMemories }}</p>
      <ul>
        <li>
          <router-link to="/chat"><span class="big">Chat</span> </router-link>
        </li>
        <li>
          <router-link to="/agenda"><span class="big">Calendrier</span></router-link>
        </li>
        <li><a class="big" @click.prevent="signOut">Deconnexion</a></li>
      </ul>

      <router-view />
    </div>
  </div>
</template>

<script>
import { db } from "@/main";
import firebase from "firebase";

export default {
  name: "Home",
  components: {},
  data() {
    return {
      randomMemories: "",
    };
  },
  mounted() {
    this.getMemories();
  },

  methods: {
    // **************************************************************************************
    // *                   Déconnecxion et redirection vers /login                          *
    // **************************************************************************************
    signOut() {
      firebase
        .auth()
        .signOut()
        .then(() => {
          this.$router.replace({
            name: "Login",
          });
        });
    },
    // ***************************************************************************************
    // *              Lecture table memory sur firebase, injection dans un tableau           *
    // *              Randomisation sur le tableau                                           *
    // *              Injection du random dans randomMemories pour affichage                 *
    // *                                                                                     *
    // * await                                                                               *
    // * ne peut être utilisé que dans une fonction async.                                   *
    // * Il permet d’attendre la résolution d’une promesse et retourner sa valeur.           *
    // * *************************************************************************************
    async getMemories() {
      let snapshot = await db.collection("memory").get();
      let arrayMemory = [];
      snapshot.forEach((memo) => {
        arrayMemory.push(memo.data().memories);
      });

  // *******************************************************************************************
  // *            Math.random()                                                                *
  // *   Retourne un nombre pseudo-aléatoire compris entre 0 (inclus) et 1 (exclu).            *
  // *            Math.floor(x)                                                                * 
  // *   Retourne le plus grand entier inférieur ou égal à la valeur passée en paramètre.      *
  // *******************************************************************************************
      const random =
        arrayMemory[Math.floor(Math.random() * arrayMemory.length)];

      this.randomMemories = random;
    },
  },
};
</script>

<style scoped>
#app {
  margin: 0;
  height: 100vh;
  display: flex;
  align-items: center;
  justify-content: center;
  background: cornsilk;
}
.bg {
  height: 450px;
}

ul {
  padding: 0;
  margin: auto;
  list-style-type: none;
  height: 100%;
  /* max-height: 600px; */
  width: 1000px;
  background-color: #b8cefd;
  opacity: 100%;
  background-image: url("https://78.media.tumblr.com/cae86e76225a25b17332dfc9cf8b1121/tumblr_p7n8kqHMuD1uy4lhuo1_540.png"),
    url("https://78.media.tumblr.com/66445d34fe560351d474af69ef3f2fb0/tumblr_p7n908E1Jb1uy4lhuo1_1280.png"),
    url("https://78.media.tumblr.com/8cd0a12b7d9d5ba2c7d26f42c25de99f/tumblr_p7n8kqHMuD1uy4lhuo2_1280.png"),
    url("https://78.media.tumblr.com/5ecb41b654f4e8878f59445b948ede50/tumblr_p7n8on19cV1uy4lhuo1_1280.png"),
    url("https://78.media.tumblr.com/28bd9a2522fbf8981d680317ccbf4282/tumblr_p7n8kqHMuD1uy4lhuo3_1280.png");
  background-repeat: repeat-x;
  background-position: 0 20%, 0 100%, 0 50%, 0 100%, 0 0;
  background-size: 2500px, 800px, 500px 200px, 1000px, 400px 260px;
  animation: 50s para infinite linear;
}

@keyframes para {
  100% {
    background-position: -5000px 20%, -800px 95%, 500px 50%, 1000px 100%,
      400px 0;
  }
}

ul li {
  box-sizing: border-box;
  width: 15em;
  height: 3em;
  font-size: 20px;
  border-radius: 0.5em;
  margin: 0.5em;
  box-shadow: 0 0 1em rgba(0, 0, 0, 0.2);
  color: rgb(236, 14, 14);
  font-family: sans-serif;
  text-transform: capitalize;
  line-height: 3em;
  transition: 0.3s;
  cursor: pointer;
  text-decoration: none;
  font-family: "BlueEyes";
}

ul li:nth-child(odd) {
  background: linear-gradient(to right, rgb(3, 141, 61), rgb(104, 175, 128));
  text-align: left;
  padding-left: 2%;
  transform: perspective(500px) rotateY(45deg);
}

ul li:nth-child(even) {
  background: linear-gradient(to left, rgb(3, 141, 61), rgb(104, 175, 128));
  text-align: right;
  padding-left: 0%;
  transform: perspective(500px) rotateY(-45deg);
}

ul li:nth-child(odd):hover {
  transform: perspective(200px) rotateY(45deg);
  padding-left: 5%;
}

ul li:nth-child(even):hover {
  transform: perspective(200px) rotateY(-45deg);
  padding-right: 5%;
}
.big {
  color: black;
  font-size: 40px;
  padding-right: 5px;
}
p {
  font-size: 2em;
  color: #f3bc06;
  border: rgb(12, 12, 12) 1px solid;
  border-bottom: rgb(10, 10, 10) 2px solid;
  background-color: rgb(104, 175, 128);
  font-family: "BrighlyCrush";
  padding: 5px;
}
</style>
